package com.Wwif.Example;

import java.awt.*;
import java.awt.event.*;

// Import the two classes that the Application controlled needs to know about
import com.Wwif.MenuEventObject;
import com.Wwif.MenuListener;

public class ExampleApplication extends    java.awt.Panel 
                             implements    java.io.Serializable,
                                           MenuListener
{
	/**
	 * Main routine for testing and demonstration only.
	 */
	 
	public ExampleApplication()
	{
  // Test code so we can see the scripts the application receives
		addMenuListener(this);

  // Code for application goes here ...

	}
  public synchronized void paint(Graphics g) 
  {
  	int width = getSize().width;
  	int height = getSize().height;

  	g.setColor(Color.green);           // raised
  	g.fill3DRect(0, 0, width - 1, height - 1, true);

  	g.setColor(getForeground());
  	g.setFont(getFont());

  	g.drawRect(2, 2, width - 4, height - 4);

  	FontMetrics fm = g.getFontMetrics();
    if ( scriptField.getText() != null )
    {
    	g.drawString(scriptLabel.getText(), (width - fm.stringWidth(scriptLabel.getText())) / 2, 
  		          2*TEXT_YPAD);

    	g.drawString(scriptField.getText(), (width - fm.stringWidth(scriptField.getText())) / 2, 
  		          2*TEXT_YPAD + fm.getMaxAscent() + fm.getMaxDescent());
    }
  }

  public Dimension getPreferredSize() 
  {
  	FontMetrics fm = getFontMetrics(getFont());
  	return new Dimension(fm.stringWidth(scriptLabel.getText()) + TEXT_XPAD, 
  			     2*(fm.getMaxAscent() + fm.getMaxDescent() + TEXT_YPAD));
  }

  public Dimension getMinimumSize() 
  {
	  return getPreferredSize();
  }

	//
	// Implement the add... and remove... listener methods, according to
	// the required design pattern.
	//
	
	/**
	 * Add a new menu listener (target) for menu events created by this bean.
	 */
	 
	public synchronized void addMenuListener(MenuListener ml)
	{
		menuListeners.addElement(ml);
	}
	
	/**
	 * Remove a menu event listener.
	 */
	 
	public synchronized void removeMenuListener(MenuListener ml)
	{
		menuListeners.removeElement(ml);
	}
	
	/**
	 * The list of listeners to this bean, for menu events. This list, like
	 * all references from a bean to external objects, should be transient.
	 */
	 
	private transient java.util.Vector menuListeners = new java.util.Vector();

	/**
	 * The callback this menu listener must implement, for menu event
	 * sources to invoke (directly, or via an event queue thread).
	 */
	 
	public void processMenuEvent(MenuEventObject meo)
	{
//System.out.println("DemoApplication: processMenuEvent");
		if (meo.id != MenuEventObject.MENU_APPLICATION_SCRIPT) 
    {
      return;
    }
    else
    {
      scriptField.setText(meo.getScript());
      repaint();
    }
/*				
		// Invoke event handler for each listener
		
		java.util.Vector listeners;
		
		synchronized (this)
		{
			listeners = (java.util.Vector)(menuListeners.clone());
		}
		for (int i = 0; i < listeners.size(); i++)
			// each listener...
		{
			// Invoke the listener's handler
			MenuListener ml = (MenuListener)(listeners.elementAt(i));
			ml.processMenuEvent(meo);
		}
*/
	}

	private     Label        scriptLabel = new Label(
                                        "Command received by Application:");
	private     TextField    scriptField = new TextField("(none)");

  static final int TEXT_XPAD = 12;
  static final int TEXT_YPAD = 8;
}


